<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\LoginService;
use FM\Traits\TResponse;

class LoginController
{
    use TResponse;
    protected $LoginService;

    public function __construct(LoginService $LoginService)
    {
        $this->LoginService = $LoginService;
    }

    public function signUp(Request $request)
    {
        try {
            $data = $this->LoginService->signUp($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function signIn(Request $request)
    {
        try {
            $data = $this->LoginService->signIn($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function signOut()
    {
        try {
            var_dump('cheguei aqui');
            $this->LoginService->signOut();
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
