<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class LoginFactory
{

    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function signUp($parametros)
    {
        $sql = "INSERT INTO USUARIOAPP (NRORG, NRUSUARIOAPP, DSEMAILUSUARIOAPP, DSULTIMONOME, DSPRIMEIRONOME, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, 
                    DSSENHAUSUARIOAPP)
                VALUES (:NRORG, :NRUSUARIOAPP, :DSEMAILUSUARIOAPP, :DSULTIMONOME, :DSPRIMEIRONOME, 'S', SYSDATE, SYSDATE, :NRORGINCLUSAO, :DSSENHAUSUARIOAPP)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function signIn($parametros)
    {
        $sql = "SELECT DSEMAILUSUARIOAPP, DSPRIMEIRONOME, DSULTIMONOME, NRUSUARIOAPP
                  FROM USUARIOAPP
                 WHERE DSEMAILUSUARIOAPP = :DSEMAILUSUARIOAPP
                   AND DSSENHAUSUARIOAPP = :DSSENHAUSUARIOAPP";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }
}
