<?php

namespace FM\Service;

use FM\Factory\LoginFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;

class LoginService
{
    protected $LoginFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;
    protected $clientId;
    protected $clientSecret;

    public function __construct(LoginFactory $LoginFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager)
    {
        $this->LoginFactory                 = $LoginFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
        $this->clientId                     = "cd7e85178153by60953518945f9hakt19a50a4";
        $this->clientSecret                 = "lib5449996c21f780fe30badd6521931a5sac9";
    }

    public function signUp($parametros)
    {
        $this->connection->beginTransaction();

        try {
            $nomeUsuario = $this->getFirstAndLastName($parametros['NAME']);

            $this->LoginFactory->signUp(array(
                "NRUSUARIOAPP"      => $this->newCode->getCodeByTableName("nome_tabela", 20, 1, 10, true),
                "DSEMAILUSUARIOAPP" => $parametros['EMAIL'],
                "DSULTIMONOME"      => $nomeUsuario['ultimo_nome'],
                "DSPRIMEIRONOME"    => $nomeUsuario['primeiro_nome'],
                "NRORG"             => 20,
                "NRORGINCLUSAO"     => 20,
                "DSSENHAUSUARIOAPP" => md5($parametros['PASSWORD'])
            ));

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function getFirstAndLastName($name)
    {
        // Dividindo o nome em partes usando o espaço como delimitador
        $parts = explode(" ", $name);

        // Obtendo o primeiro e o último nome
        $first_name = $parts[0];
        $last_name = end($parts);

        // Retornando os nomes em um array
        return array("primeiro_nome" => $first_name, "ultimo_nome" => $last_name);
    }

    public function signIn($parametros)
    {
        $sessionId = InstanceManager::getInstance()->getService('session')->getId();
        $token = InstanceManager::getInstance()->getService('oAuthImpl')->grantAccessToken($this->clientId, $this->clientSecret, array('sessionId' => $sessionId));

        $dados = array();
        $dados = $this->LoginFactory->signIn(array(
            "DSEMAILUSUARIOAPP" => $parametros['EMAIL'],
            "DSSENHAUSUARIOAPP" => md5($parametros['PASSWORD'])
        ));

        if (!empty($dados)) {
            $dados[0]['LOGIN_TOKEN'] = $token;
            $this->initSession($dados[0]);
            return $dados;
        } else {
            throw new \Exception("Não foi possível localizar os dados do cadastro. Certique-se de que o e-mail e senha estejam corretos ou cadastre-se.");
        }
    }

    private function initSession($parametros)
    {
        $session = InstanceManager::getInstance()->getService('session');
        $session->start();

        $session->set('NRUSUARIOAPP', $parametros['NRUSUARIOAPP']);
        $session->set('LOGIN_TOKEN', $parametros['LOGIN_TOKEN']);
        // $session->get('NRUSUARIOAPP');
    }

    public function signOut()
    {
        $session = InstanceManager::getInstance()->getService('session');
        $session->start();

        $token = $session->get('LOGIN_TOKEN');

        InstanceManager::getInstance()->getService('oAuthImpl')->getOAuthCustom()->deleteToken($token);
        $session->destroy();
    }
}
